package com.codvision.base.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.codvision.base.entity.SysConfig;
import com.codvision.base.entity.vo.SysConfigVO;
import com.codvision.webcore.bean.QueryPage;
import com.codvision.webcore.service.IBaseService;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 系统配置 服务类
 * </p>
 *
 * @author lingee
 * @since 2023-11-09
 */
public interface ISysConfigService extends IBaseService<SysConfig, SysConfigVO> {

    /**
     * 获取系统配置详情
     *
     * @param id
     * @return 系统配置
     */
    SysConfigVO getDetail(Long id);

    /**
     * 分页查询系统配置
     *
     * @param queryPage 分页参数
     * @return 分页结果
     */
    IPage<SysConfigVO> getPageResult(QueryPage<SysConfig> queryPage);

    /**
     * 根据条件查询系统配置
     *
     * @param queryBean 查询条件
     * @return 系统配置列表
     */
    List<SysConfigVO> listAll(SysConfig queryBean);

    /**
     * 根据配置名获取系统配置
     *
     * @param key 配置名
     * @return 系统配置
     */
    SysConfig getByKey(String key);

    /**
     * 根据配置名获取系统配置值
     *
     * @param key 配置名
     * @return 系统配置值
     */
    String getValueByKey(String key);

    /**
     * 根据配置名获取系统配置值
     *
     * @param key 配置名
     * @return 系统配置值
     */
    String getValueThrowException(String key);

    /**
     * 根据分类获取系统配置列表
     *
     * @param largeCategory 系统分类
     * @return 系统配置列表
     */
    Map<String, List<SysConfig>> getListByLargeCategory(String largeCategory);

    /**
     * 更新系统配置
     *
     * @param sysConfigs 系统配置
     */
    void updateAll(List<SysConfig> sysConfigs);

    /**
     * 根据系统配置名列表获取系统配置
     *
     * @param keys 配置名列表
     * @return
     */
    List<SysConfig> getListByKeys(List<String> keys);
}
